﻿using System.Runtime.InteropServices;

namespace TestProject
{
    /// <summary>
    /// WEBP 비트 스트림 특징
    /// </summary>
    [StructLayoutAttribute(LayoutKind.Sequential)]
    public struct WEBPBitStreamFeatures
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 너비
        /// </summary>
        public int Width;

        /// <summary>
        /// 높이
        /// </summary>
        public int Height;

        /// <summary>
        /// 알파 여부
        /// </summary>
        public int HasAlpha;

        /// <summary>
        /// 애니메이션 여부
        /// </summary>
        public int HasAnimation;

        /// <summary>
        /// 포맷
        /// </summary>
        public int Format;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 패딩
        /// </summary>
        [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 5, ArraySubType = UnmanagedType.U4)]
        private readonly uint[] Padding;

        #endregion
    };
}