﻿using System;
using System.Runtime.InteropServices;

namespace TestProject
{
    /// <summary>
    /// WEBP 디코더 버퍼
    /// </summary>
    [StructLayoutAttribute(LayoutKind.Sequential)]
    public struct WEBPDecoderBuffer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 색상 공간
        /// </summary>
        public WEBP_CSP_MODE ColorSpace;

        /// <summary>
        /// 너비
        /// </summary>
        public int Width;

        /// <summary>
        /// 높이
        /// </summary>
        public int Height;

        /// <summary>
        /// 외부 메모리 여부
        /// </summary>
        /// <remarks>
        /// 0이 아니면 'internal_memory' 포인터를 사용하지 않는다.
        /// 값이 '2' 이상이면 외부 메모리가 '느림'으로 간주되어 다중 읽기/쓰기가 방지된다.
        /// </remarks>
        public int IsExternalMemory;

        /// <summary>
        /// U
        /// </summary>
        /// <remarks>출력 버퍼 매개변수</remarks>
        public RGBA_YUVA_Buffer U;

        /// <summary>
        /// 패딩 1
        /// </summary>
        private readonly uint Padding1;

        /// <summary>
        /// 패딩 2
        /// </summary>
        private readonly uint Padding2;

        /// <summary>
        /// 패딩 3
        /// </summary>
        private readonly uint Padding3;

        /// <summary>
        /// 패딩 4
        /// </summary>
        private readonly uint Padding4;

        /// <summary>
        /// 전용 메모리
        /// </summary>
        /// <remarks>
        /// 내부적으로 할당된 메모리(is_external_memory가 0인 경우에만)
        /// 외부에서 사용해서는 안 되지만 WebPRGBABuffer를 통해 액세스해야 한다.
        /// </remarks>
        public IntPtr PrivateMemory;

        #endregion
    }
}