﻿using System.Runtime.InteropServices;

namespace TestProject
{
    /// <summary>
    /// WEBP 디코더 구성
    /// </summary>
    [StructLayoutAttribute(LayoutKind.Sequential)]
    public struct WEBPDecoderConfiguration
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 입력
        /// </summary>
        /// <remarks>불변 비트 스트림 기능(선택 사항)</remarks>
        public WEBPBitStreamFeatures Input;

        /// <summary>
        /// 출력
        /// </summary>
        /// <remarks>출력 버퍼(외부 메모리를 가리킬 수 있음)</remarks>
        public WEBPDecoderBuffer Output;

        /// <summary>
        /// 디코딩 옵션
        /// </summary>
        public WEBPDecoderOptions Options;

        #endregion
    }
}