﻿using System;
using System.Runtime.InteropServices;

namespace TestProject
{
    /// <summary>
    /// WEBP YUVA 버퍼
    /// </summary>
    [StructLayoutAttribute(LayoutKind.Sequential)]
    public struct WEBPYUVABuffer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// Y
        /// </summary>
        /// <remarks>루마 샘플에 대한 포인터</remarks>
        public IntPtr Y;

        /// <summary>
        /// U
        /// </summary>
        /// <remarks>크로마 U 샘플에 대한 포인터</remarks>
        public IntPtr U;

        /// <summary>
        /// V
        /// </summary>
        /// <remarks>크로마 V 샘플에 대한 포인터</remarks>
        public IntPtr V;

        /// <summary>
        /// A
        /// </summary>
        /// <remarks>알파 샘플에 대한 포인터</remarks>
        public IntPtr A;

        /// <summary>
        /// Y 스트라이드
        /// </summary>
        /// <remarks>루마 스트라이드</remarks>
        public int YStride;

        /// <summary>
        /// U 스트라이드
        /// </summary>
        /// <remarks>크로마 U 스트라이드</remarks>
        public int UStride;

        /// <summary>
        /// V 스트라이드
        /// </summary>
        /// <remarks>크로마 V 스트라이드</remarks>
        public int VStride;

        /// <summary>
        /// A 스트라이드
        /// </summary>
        /// <remarks>알파 스트라이드</remarks>
        public int AStride;

        /// <summary>
        /// Y 크기
        /// </summary>
        /// <remarks>루마 평면 크기</remarks>
        public UIntPtr YSize;

        /// <summary>
        /// U 크기
        /// </summary>
        /// <remarks>크로마 평면 U사이즈</remarks>
        public UIntPtr USize;

        /// <summary>
        /// V 크기
        /// </summary>
        /// <remarks>크로마 평면 V사이즈</remarks>
        public UIntPtr VSize;

        /// <summary>
        /// A 크기
        /// </summary>
        /// <remarks>알파 평면 크기</remarks>
        public UIntPtr ASize;

        #endregion
    }
}